//+------------------------------------------------------------------+
//|                                                     Elucidator   |
//|                                                                  |
//|                                            Coded By Darren/Romek |
//+------------------------------------------------------------------+
#property copyright "Darren/Romek"
#property link      "mine"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_buffers 1
#property indicator_color1 LawnGreen
#property indicator_width1  4
#property indicator_level1 0.5
#property indicator_levelstyle 0
#property indicator_levelwidth 2
//---- input parameters
extern int DeMarkerPeriod=9;
extern bool Use_Alert=true;
extern bool EMail_Signals=true;
//---- buffers
double DeMarkerBuffer[];
double ExtMaxBuffer[];
double ExtMinBuffer[];
int    currBars;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(3);
   SetIndexBuffer(0,DeMarkerBuffer);
   SetIndexBuffer(1,ExtMaxBuffer);
   SetIndexBuffer(2,ExtMinBuffer);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
//---- name for DataWindow and indicator subwindow label
   short_name="\Pilotui_Elucidator/";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//---- first values aren't drawn
   SetIndexDrawBegin(0,DeMarkerPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| DeMarker                                                         |
//+------------------------------------------------------------------+
int start()
  {
   double dNum;
   int    i,nCountedBars;
//---- insufficient data
   if(Bars<=DeMarkerPeriod) return(0);
//---- bars count that does not changed after last indicator launch.
   nCountedBars=IndicatorCounted();
//----
   ExtMaxBuffer[Bars-1]=0.0;
   ExtMinBuffer[Bars-1]=0.0;
   if(nCountedBars>2) i=Bars-nCountedBars-1;
   else               i=Bars-2;
   while(i>=0)
     {
      dNum=High[i]-High[i+1];
      if(dNum<0.0) dNum=0.0;
      ExtMaxBuffer[i]=dNum; 
      
      dNum=Low[i+1]-Low[i];
      if(dNum<0.0) dNum=0.0;
      ExtMinBuffer[i]=dNum; 

      i--;
     }   
//---- initial zero
   if(nCountedBars<1)
      for(i=1; i<=DeMarkerPeriod; i++)
         DeMarkerBuffer[Bars-i]=0.0;   
//----
   i=Bars-DeMarkerPeriod-1;
   if(nCountedBars>=DeMarkerPeriod) i=Bars-nCountedBars-1;
   while(i>=0)
     {
      dNum=iMAOnArray(ExtMaxBuffer,0,DeMarkerPeriod,0,MODE_SMA,i)+
           iMAOnArray(ExtMinBuffer,0,DeMarkerPeriod,0,MODE_SMMA,i);
      if(dNum!=0.0)
         DeMarkerBuffer[i]=iMAOnArray(ExtMaxBuffer,0,DeMarkerPeriod,0,MODE_SMA,i)/dNum;
      else
         DeMarkerBuffer[i]=0.0;
      
      i--;
     }
   

   if ((DeMarkerBuffer[2]<0.5 && DeMarkerBuffer[1]>0.5) || (DeMarkerBuffer[2]>0.5 && DeMarkerBuffer[1]<0.5) && currBars!=Bars)
   {
      if (Use_Alert) Alert(Symbol(),": TRUE ALF ALERT");
      if (EMail_Signals) SendMail(Symbol() +" M"+Period() + " TRUE ALF ALERT ",Symbol() +" M"+Period() +" <<TRUE ALF ALERT>>");
      currBars=Bars;
   }
   
   /*if ((DeMarkerBuffer[2]<0.7 && DeMarkerBuffer[1]>0.7) || (DeMarkerBuffer[2]>0.7 && DeMarkerBuffer[1]<0.7) && currBars!=Bars)
   {
      if (Use_Alert) Alert(Symbol(),": DeMarker crossed 0.7 level");
      if (EMail_Signals) SendMail(Symbol()+": DeMarker cross","DeMarker crossed 0.7 level");
      currBars=Bars;
   }*/
   return(0);
  }
//+------------------------------------------------------------------+

